Index: trunk/platforms/tsar_generic_iob/tsar_iob_cluster/caba/source/include/tsar_iob_cluster.h
===================================================================
--- trunk/platforms/tsar_generic_iob/tsar_iob_cluster/caba/source/include/tsar_iob_cluster.h	(revision 802)
+++ trunk/platforms/tsar_generic_iob/tsar_iob_cluster/caba/source/include/tsar_iob_cluster.h	(revision 959)
@@ -70,5 +70,5 @@
     // interrupt signals
     sc_signal<bool>                       signal_false;
-    sc_signal<bool>                       signal_proc_it[16];
+    sc_signal<bool>                       signal_proc_it[32];
     sc_signal<bool>                       signal_irq_mdma[8];
     sc_signal<bool>                       signal_irq_memc;
@@ -198,8 +198,8 @@
                     const soclib::common::MappingTable &mt_iox,
 
-                    size_t                             x_width,       // x field  bits
-                    size_t                             y_width,       // y field  bits
-                    size_t                             l_width,       // l field  bits
-                    size_t                             p_width,       // p field  bits
+                    size_t                             x_width,   // x field  bits
+                    size_t                             y_width,   // y field  bits
+                    size_t                             l_width,   // l field  bits
+                    size_t                             p_width,   // p field  bits
 
                     size_t                             int_memc_tgt_id,
@@ -226,7 +226,10 @@
                     size_t                             l1_d_sets,   
                     size_t                             xram_latency, 
-                    size_t                             xcu_nb_inputs,
-
-                    const Loader                       &loader,       // loader for XRAM
+                    size_t                             xcu_nb_hwi,
+                    size_t                             xcu_nb_pti,
+                    size_t                             xcu_nb_wti,
+                    size_t                             xcu_nb_irq,
+
+                    const Loader                       &loader,  // loader for XRAM
 
                     uint32_t                           frozen_cycles, 
Index: trunk/platforms/tsar_generic_iob/tsar_iob_cluster/caba/source/src/tsar_iob_cluster.cpp
===================================================================
--- trunk/platforms/tsar_generic_iob/tsar_iob_cluster/caba/source/src/tsar_iob_cluster.cpp	(revision 802)
+++ trunk/platforms/tsar_generic_iob/tsar_iob_cluster/caba/source/src/tsar_iob_cluster.cpp	(revision 959)
@@ -72,5 +72,8 @@
                     size_t                             l1_d_sets,
                     size_t                             xram_latency,
-                    size_t                             xcu_nb_inputs,
+                    size_t                             xcu_nb_hwi,
+                    size_t                             xcu_nb_pti,
+                    size_t                             xcu_nb_wti,
+                    size_t                             xcu_nb_out,
 
                     const Loader                      &loader,
@@ -178,8 +181,8 @@
                      mt_int,                              // mapping table INT network
                      IntTab(cluster_id, int_xicu_tgt_id), // TGTID direct space
-                     xcu_nb_inputs,                       // number of timer IRQs
-                     xcu_nb_inputs,                       // number of hard IRQs
-                     xcu_nb_inputs,                       // number of soft IRQs
-                     16);                                 // number of output IRQs
+                     xcu_nb_pti,                          // number of timer IRQs
+                     xcu_nb_hwi,                          // number of hard IRQs
+                     xcu_nb_wti,                          // number of soft IRQs
+                     xcu_nb_out);                         // number of output IRQs
 
     ////////////  MDMA
@@ -503,9 +506,9 @@
     xicu->p_resetn                               (this->p_resetn);
     xicu->p_vci                                  (signal_int_vci_tgt_xicu);
-    for ( size_t i=0 ; i < 16  ; i++)
+    for ( size_t i=0 ; i < xcu_nb_out  ; i++)
     {
         xicu->p_irq[i]                           (signal_proc_it[i]);
     }
-    for ( size_t i=0 ; i < xcu_nb_inputs ; i++)
+    for ( size_t i=0 ; i < xcu_nb_hwi ; i++)
     {
         if      ( i == 0 )       xicu->p_hwi[i]  (signal_irq_memc);